import java.io.*;
import java.util.*;


public class sigparser    // args[0] is file name
{

    public static ctype parsetype(Tokens tk) throws Exception  //first order
    {
	if (tk==null) throw new Exception();
	if (tk.countTokens() == 1)
	    return new primtype(tk.nextToken());
	else
	    {
	      String tok = tk.nextToken();
	      return new artype(new primtype(tok), parsetype(tk));
	    }
    } //parsetype

   public static colsig parsefile(String sig)
    {
     colsig csig = new colsig("dummy",new primtype("int"),null); // dummy
     colsig current = csig;
     try
      { String line, id;
        ctype ty;
	BufferedReader br = new BufferedReader(new FileReader(sig));
	line = ""+(char)37; // %
	while ((line!=null) && (line.charAt(0) == (char)37)) 
	    line = br.readLine();
	while ((line !=null) && (line.charAt(0) != '$'))
	    {
	        Tokens tk = new Tokens(line," \t\n\r\f:$.()->", false);
		//			System.out.println(tk);  // debug
		id = tk.nextToken();
		ty = parsetype(tk);
		current.next = new colsig(id,ty,null);
		current = current.next;
		line = ""+(char)37; // %
		while ((line!=null) && (line.charAt(0) == (char)37)) 
		    line = br.readLine();
		//		System.out.println(line);  // debug
	    }

      }
     catch (Exception e) {e.printStackTrace(); System.exit(1); }
     return csig.next;
    } // colsig

} //colparser



